<?php
/**
 * Plugin Name: HM Car Toll
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: [hm_car_toll]
 * Version:     3.6
 * Author:      Mahdi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: hm-car-toll
 * Domain Path: /languages
 * 
 */ 
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}
define("hmct_url", plugin_dir_url(__FILE__));
function hmct_load_textdomain() {
  load_plugin_textdomain( 'hm-car-toll', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
} 
add_action( 'plugins_loaded', 'hmct_load_textdomain' );
if ( ! class_exists( 'hm_car_toll' ) ) {
	class hm_car_toll {
		private static $settings;
		private function __construct() {
		} 
		public static function init_actions() {
			$plugin_data = get_file_data(__FILE__, [
				'Version' => 'Version',
				'TextDomain' => 'Text Domain'
			], 'plugin');
			//$hm_car_toll_plugin_data = get_plugin_data( __FILE__ );
			define("hm_car_toll_version",$plugin_data['Version']); 
			register_activation_hook( __FILE__, array( __CLASS__, 'activate' ) );
			register_deactivation_hook(__FILE__, array( __CLASS__, 'deactivat'));
			register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
			add_shortcode('hm_car_toll', array( __CLASS__ , 'echo_shortcode'));
			add_action( 'admin_menu', array( __CLASS__ , 'add_admin_menu' ) );
			add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( __CLASS__, 'add_settings_link' ), 10, 2 );
			add_action( 'admin_enqueue_scripts', array( __CLASS__, 'enqueue_backend' ) );
			add_action( 'wp_enqueue_scripts', array( __CLASS__, 'enqueue_front' ) );
			add_action( 'wp_ajax_hm_car_toll_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'wp_ajax_nopriv_hm_car_toll_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'rest_api_init', array( __CLASS__,'register_route') );
			$settings = self::get_settings();
			//if ( $settings['xxx'] ) {
			//} else {
			//}
		}
		//https://www.hamrah-mechanic.com/mag/wp-json/vehicle/get_all_vehicle_makers/1
		public static function register_route(){
			register_rest_route( 'vehicle', 'get_all_vehicle_makers/(?P<id>\d+)', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_makers' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					//return current_user_can( 'edit_others_posts' );
					return true;
				}, 
			));
			//https://www.hamrah-mechanic.com/mag/wp-json/vehicle/get_vehicle_models_by_maker/fb7dbbea-9e48-e911-80ea-005056bd1d96
			register_rest_route( 'vehicle', 'get_vehicle_models_by_maker/(?P<id>[a-zA-Z0-9-]+)', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_selected_models' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					//return current_user_can( 'edit_others_posts' );
					return true;
				}, 
			));
			//https://www.hamrah-mechanic.com/mag/wp-json/vehicle/get_vehicle_tips_by_model/015f6a12-9f48-e911-80ea-005056bd1d96
			register_rest_route( 'vehicle', 'get_vehicle_tips_by_model/(?P<id>[a-zA-Z0-9-]+)', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_selected_tips' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					//return current_user_can( 'edit_others_posts' );
					return true;
				}, 
			));
			//https://www.hamrah-mechanic.com/mag/wp-json/vehicle/get_vehicle_year_by_tip/d852b740-a448-e911-80ea-005056bd1d96
			register_rest_route( 'vehicle', 'get_vehicle_year_by_tip/(?P<id>[a-zA-Z0-9-]+)', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_selected_years' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					//return current_user_can( 'edit_others_posts' );
					return true;
				}, 
			));
			// /wp-json/vehicle/get_all_registered_car_in_db
			register_rest_route( 'vehicle', 'get_all_registered_car_in_db', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_all_registered_car' ),
			));
			// /wp-json/vehicle/update_selected_car
			register_rest_route( 'vehicle', 'update_selected_car', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'update_selected_car_func' ),
			));
			// /wp-json/vehicle/delete_selected_car
			register_rest_route( 'vehicle', 'delete_selected_car', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'delete_selected_car_func' ),
			));
			
			// /wp-json/vehicle/delete_selected_car
			register_rest_route( 'vehicle', 'calculate_car_toll', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'calculate_car_toll_func' ),
			));
		}
		public static function get_makers( $data ) {
			// default the author list to all
			$guid = '';
			// if ID is set
			if( isset( $data[ 'id' ] ) ) {
				  $guid = $data[ 'id' ];
			}
			// get the posts
			$posts_list = get_posts( array( 'type' => 'post', 'author' => $post_author ) );
			$post_data = array(
				array( 'type' => 'post', 'author' => '5' ),
				array( 'type' => 'post', 'author' => '6' )
			);
			$data = array(
				"test" => "5",
			);                                                                    
			//Generate URL-encoded query string
			$data_string =  http_build_query($post_data);
			$new_connection = curl_init('https://crmapi.hamrah-mechanic.com/api/GetAllVehicleMakers');
			curl_setopt($new_connection, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($new_connection, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($new_connection, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($new_connection, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($new_connection, CURLOPT_CUSTOMREQUEST, 'GET');
			curl_setopt($new_connection, CURLOPT_HTTPHEADER, array(                                                                          
				'Content-Type: application/x-www-form-urlencoded',                                                                                
				'UserName: wp_hm',
				'Password: W!p2o2o',
				)                                                                       
			); 
			$new_result = curl_exec($new_connection);
			curl_close($new_connection);
			return rest_ensure_response( $new_result );
		}
		public static function get_selected_models( $data ) {
			$guid = '';
			if( isset( $data[ 'id' ] ) ) {
				  $guid = $data[ 'id' ];
			}
			$url = 'http://crmapi.hamrah-mechanic.com/api/GetVehicleModels?MakerGuid='.$guid;
			$new_connection = curl_init($url);
			curl_setopt($new_connection, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($new_connection, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($new_connection, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($new_connection, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($new_connection, CURLOPT_CUSTOMREQUEST, 'GET');
			curl_setopt($new_connection, CURLOPT_HTTPHEADER, array(                                                                          
				'Content-Type: application/x-www-form-urlencoded',                                                                                
				'UserName: wp_hm',
				'Password: W!p2o2o',
				)                                                                       
			); 
			$new_result = curl_exec($new_connection);
			curl_close($new_connection);
			return rest_ensure_response( $new_result );
		}
		public static function get_selected_tips( $data ) {
			// default the author list to all
			$guid = '';
			if( isset( $data[ 'id' ] ) ) {
				  $guid = $data[ 'id' ];
			}
			$url = 'https://crmapi.hamrah-mechanic.com/api/GetVehicleTips?ModelGuid='.$guid;
			$new_connection = curl_init($url);
			curl_setopt($new_connection, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($new_connection, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($new_connection, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($new_connection, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($new_connection, CURLOPT_CUSTOMREQUEST, 'GET');
			curl_setopt($new_connection, CURLOPT_HTTPHEADER, array(                                                                          
				'Content-Type: application/x-www-form-urlencoded',                                                                                
				'UserName: wp_hm',
				'Password: W!p2o2o',
				)                                                                       
			); 
			$new_result = curl_exec($new_connection);
			curl_close($new_connection);
			return rest_ensure_response( $new_result );
		}
		public static function get_selected_years( $data ) {
			// default the author list to all
			$guid = '';
			if( isset( $data[ 'id' ] ) ) {
				  $guid = $data[ 'id' ];
			}
			$url = 'https://crmapi.hamrah-mechanic.com/api/GetVehiclesByTip?TipGuid='.$guid;
			$new_connection = curl_init($url);
			curl_setopt($new_connection, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($new_connection, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($new_connection, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($new_connection, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($new_connection, CURLOPT_CUSTOMREQUEST, 'GET');
			curl_setopt($new_connection, CURLOPT_HTTPHEADER, array(                                                                          
				'Content-Type: application/x-www-form-urlencoded',                                                                                
				'UserName: wp_hm',
				'Password: W!p2o2o',
				)                                                                       
			); 
			$new_result = curl_exec($new_connection);
			curl_close($new_connection);
			return rest_ensure_response( $new_result );
		}
		//get_all_registered_car
		public static function get_all_registered_car() {
			// default the author list to all
			$results = get_posts(array(
			   'post_type' => 'hm_car',
			   'numberposts'=> '-1',
			));
			
			$data = array();
			$options = array();
			$files = array();
			
			if(!empty($results)){
				foreach($results as $index => $p_obj){
					$obj = new stdClass();
					$obj->id = $p_obj->ID;
					$obj->hmct_maker_guid = get_post_meta( $p_obj->ID, 'hmct_maker_guid', true );
					$obj->hmct_maker_id = get_post_meta( $p_obj->ID, 'hmct_maker_id', true );
					$obj->hmct_maker_name = get_post_meta( $p_obj->ID, 'hmct_maker_name', true );
					$obj->hmct_model_guid = get_post_meta( $p_obj->ID, 'hmct_model_guid', true );
					$obj->hmct_model_id = get_post_meta( $p_obj->ID, 'hmct_model_id', true );
					$obj->hmct_model_name = get_post_meta( $p_obj->ID, 'hmct_model_name', true );
					$obj->hmct_tip_guid = get_post_meta( $p_obj->ID, 'hmct_tip_guid', true );
					$obj->hmct_tip_id = get_post_meta( $p_obj->ID, 'hmct_tip_id', true );
					$obj->hmct_tip_name = get_post_meta( $p_obj->ID, 'hmct_tip_name', true );
					$obj->hmct_official_name = get_post_meta( $p_obj->ID, 'hmct_official_name', true );
					$obj->hmct_official_price = get_post_meta( $p_obj->ID, 'hmct_official_price', true );
					$obj->DT_RowId = 'row_'.$p_obj->ID;
					$data[] = $obj;
					
				}
			}
			
			$to_return = array('data' => $data,'options' => $options,'files' => $files);
			
			return rest_ensure_response( $to_return );
		}
		//https://www.coditty.com/code/wordpress-api-custom-route-access-post-parameters
		public static function update_selected_car_func() {
			if(isset($_POST['id']) and isset($_POST['editRowBtn']) and isset($_POST['hmct_maker_name'])){
				$data = array();
				$id = $_POST['id'];
				
				$official_price = (int)str_replace(',', '', $_POST['hmct_official_price']);
				$official_price = (string)$official_price;
				
				update_post_meta( $id, 'hmct_official_name', $_POST['hmct_official_name'] );
				update_post_meta( $id, 'hmct_official_price', $official_price );
				
				$obj = new stdClass();
				$obj->id = $id;
				$obj->hmct_wp_post_id = $id;
				$obj->hmct_maker_guid = get_post_meta( $id, 'hmct_maker_guid', true );
				$obj->hmct_maker_id = get_post_meta( $id, 'hmct_maker_id', true );
				$obj->hmct_maker_name = get_post_meta( $id, 'hmct_maker_name', true );
				$obj->hmct_model_guid = get_post_meta( $id, 'hmct_model_guid', true );
				$obj->hmct_model_id = get_post_meta( $id, 'hmct_model_id', true );
				$obj->hmct_model_name = get_post_meta( $id, 'hmct_model_name', true );
				$obj->hmct_tip_guid = get_post_meta( $id, 'hmct_tip_guid', true );
				$obj->hmct_tip_id = get_post_meta( $id, 'hmct_tip_id', true );
				$obj->hmct_tip_name = get_post_meta( $id, 'hmct_tip_name', true );
				$obj->hmct_official_name = get_post_meta( $id, 'hmct_official_name', true );
				$obj->hmct_official_price = get_post_meta( $id, 'hmct_official_price', true );
				$obj->DT_RowId = 'row_'.$id;
				$to_return = $obj;
			}else{
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		public static function delete_selected_car_func() {
			$data = array();
			if(isset($_POST['id']) and isset($_POST['hmct_maker_name'])){
				
				$id = $_POST['id'];
				wp_delete_post((int)$id);

				$to_return = true;
				
			}else{
				//$to_return = $_POST;
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		//calculate_car_toll_func
		public static function calculate_car_toll_func() {
			//$parameters = $request->get_body();
			$data = array();
			if(isset($_POST['ajax_type']) and $_POST['ajax_type'] == 'calculate_car_toll' ){
				$tip_guid = $_POST['tip_guid'];
				$query = get_posts( array(
					'post_type' => 'hm_car',
					'meta_key'   => 'hmct_tip_guid',
					'meta_value' => $tip_guid,
				) );
				
				if(!empty($query)){
					
					$post =$query[0]; 
					$post->hmct_tip_guid = get_post_meta( $post->ID, 'hmct_tip_guid', true );
					$post->hmct_official_price = (int)get_post_meta( $post->ID, 'hmct_official_price', true );
					
					$maliat_shomare_gozari_darsad = 2;
					$qaymat = $post->hmct_official_price;
					$maliat_shomare_gozari = ($maliat_shomare_gozari_darsad / 100) * $qaymat;
					$post->maliat_shomare_gozari = $maliat_shomare_gozari;
					
					$avarez_shomare_gozari_darsad = 1;
					$qaymat = $post->hmct_official_price;
					$avarez_shomare_gozari = ($avarez_shomare_gozari_darsad / 100) * $qaymat;
					$post->avarez_shomare_gozari = $avarez_shomare_gozari;
					
					$avarez_salianeh_darsad = 0.15;
					$qaymat = $post->hmct_official_price;
					$avarez_salianeh = ($avarez_salianeh_darsad / 100) * $qaymat;
					$post->avarez_salianeh = $avarez_salianeh;

					$to_return = array(
						'status' => 'car_found',
						'car' => $post,
						
					);
					
				}else{
					$to_return = array(
						'status' => 'car_not_found',
					);
					
				}
				
				
			}else{
				//$to_return = $_POST;
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		
		public static function handel_ajax(){
			if(isset($_POST) and isset($_POST['action']) and $_POST['action']='hm_car_toll_ajax'  ){
				if(isset($_POST['ajax_type']) and $_POST['ajax_type']=='hm_car_toll_add_new_car_to_db'  ){
					
					
					
					
					$official_price = (int)str_replace(',', '', $_POST['official_price']);
					$official_price = (string)$official_price;
					
					$post_array = array(
						'post_title'   => $_POST['official_name'] ,
						'post_content' => $_POST['maker_name'] .' '. $_POST['model_name'] .' '. $_POST['tip_name'] ,
						'post_status'  => 'publish',
						'post_type'	   => 'hm_car',
						'post_author'  => get_current_user_id(),
						'meta_input'   => array(
							'hmct_maker_guid' => $_POST['maker_guid'],
							'hmct_maker_id' => $_POST['maker_id'],
							'hmct_maker_name' => $_POST['maker_name'],
							'hmct_model_guid' => $_POST['model_guid'],
							'hmct_model_id' => $_POST['model_id'],
							'hmct_model_name' => $_POST['model_name'],
							'hmct_tip_guid' => $_POST['tip_guid'],
							'hmct_tip_id' => $_POST['tip_id'],
							'hmct_tip_name' => $_POST['tip_name'],
							'hmct_official_name' => $_POST['official_name'],
							'hmct_official_price' => $official_price,
						),
					);
					
					
					$results = get_posts(array(
					   // some more args here
					   
					   'post_type' => 'hm_car',
					   'meta_key'   => 'hmct_tip_guid',
					   'meta_value' => $_POST['tip_guid'],
					));
					if(empty($results)){
						$insert_result = wp_insert_post( $post_array );
						if ( is_wp_error( $insert_result ) ) {
							//$error_string = $result->get_error_message();
							//echo '<div id="message" class="error"><p>' . $error_string . '</p></div>';
							echo "<span style='color:red;'>خطا ! خودرو ثبت نشد </span>";
						}else{
							echo "<span style='color:green;'>خودرو ثبت شد</span>";
						}
					}else{
						echo "<span style='color:red;'>این خودرو قبلا ثبت شده</span>";
					}
					

					//echo '<div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px">';
					//echo '<style>code,kbd{display: inline-block;}</style>'
					//echo highlight_string("" . var_export($results , true) . "");
					//echo '</div>'; 

					
				}elseif(isset($_POST['ajax_type']) and $_POST['ajax_type']=='submit_rahvar_form'){
				}
			}else{
			}
		}
		public static function add_admin_menu(  ) { 
			/*add_menu_page(
				__( 'HM Car Toll Options', 'hm-car-toll' ),
				__( 'HM Car Toll', 'hm-car-toll' ),
				'manage_options',
				'hm_car_toll',
				array(__CLASS__,'hm_car_toll_options_page'),
				'dashicons-info'
			);*/
			add_submenu_page(
				'options-general.php',
				__( 'HM Car Toll Options', 'hm-car-toll' ),
				__( 'HM Car Toll', 'hm-car-toll' ),
				'manage_options',
				'hm_car_toll',
				array(__CLASS__,'hm_car_toll_options_page'), 
			);
		}
		
		
		public static function hm_car_toll_options_page(  ) { 
			?>
			<script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
			<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
			
			<script type="text/javascript" src="//cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js"></script>
			<link href="//cdn.datatables.net/1.10.20/css/jquery.dataTables.min.css" rel="stylesheet">
 			
			<script type="text/javascript" src="//cdn.datatables.net/responsive/2.2.3/js/dataTables.responsive.min.js"></script>
			<link href="//cdn.datatables.net/responsive/2.2.3/css/responsive.dataTables.min.css" rel="stylesheet">
			
			<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/buttons.print.min.js"></script>
			<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/dataTables.buttons.min.js"></script>
			<link href="//cdn.datatables.net/buttons/1.6.0/css/buttons.dataTables.min.css" rel="stylesheet">

			<script type="text/javascript" language="javascript" src="//cdn.datatables.net/buttons/1.6.1/js/buttons.flash.min.js"></script>
			<script type="text/javascript" language="javascript" src="//cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
			<script type="text/javascript" language="javascript" src="//cdn.datatables.net/buttons/1.6.1/js/buttons.html5.min.js"></script>
			
			
			<script type="text/javascript" src="//cdn.datatables.net/select/1.3.1/js/dataTables.select.min.js"></script>
			<link href="//cdn.datatables.net/select/1.3.1/css/select.dataTables.min.css" rel="stylesheet">
			
			
			<script type="text/javascript" src="<?php echo hmct_url.'dataTables.altEditor.free/dataTables.altEditor.free.js'; ?>"></script>
			<script type="text/javascript" src="<?php //echo hmct_url.'data-tables-editor/js/dataTables.editor.min.js'; ?>"></script>
			<link href="<?php echo hmct_url.'data-tables-editor/css/editor.dataTables.min.css'; ?>" rel="stylesheet">
			
			<script>
				<?php 
					$admin_ajax_url =  admin_url( 'admin-ajax.php' );
					echo "admin_ajax_url = '".$admin_ajax_url."';";
					echo "this_site_url = '".get_site_url()."';";//http://www.example.com
					
				?>
			</script>
			<script type="text/javascript" src="<?php echo hmct_url.'assets/back.js?v='.hm_car_toll_version; ?>"></script>
			<link href="<?php echo hmct_url.'assets/back.css?v='.hm_car_toll_version; ?>" rel="stylesheet">
			<script>
			jQuery(document).ready( function () {
				hmct_get_from_api(); 
			} );
			</script>
			<div id="hm_car_toll_main_wrapper">
			<div id="hm_car_toll_main_inner">
				<form id="hm_car_toll_add_new_form" class="hm_car_toll_add_new_form_class" action="">
					
					<div class="container car_toll_select_wrapper">
						<div class="row">
							<div class="col-sm-12"> 
								<div class="car_toll_title">
								ثبت خودرو
								<div id="car_toll_loading_ajax_select" style="position:absolute;"class="lds-dual-ring hmct_loading"></div>
								</div>
								<div class="car_toll_disc"></div>
							</div>
						</div>
					  <div class="row ">
						<div class="col-sm-2">
						  <div class="hm_car_column_title">سازنده خودرو</div>
						  <select id="hm_car_toll_maker_input" class="hm_car_toll_select_car_inputs form-control">
							  <option value="" disabled selected>انتخاب کنید</option>
							</select>
						</div>
						<div class="col-sm-2">
						  <div class="hm_car_column_title">مدل خودرو</div>
						  <select id="hm_car_toll_model_input"  class="hm_car_toll_select_car_inputs form-control" style="">
							  <option value="" disabled selected>انتخاب کنید</option>
							</select>
						</div>
						<div class="col-sm-2">
						  <div class="hm_car_column_title">تیپ خودرو</div>
						  <select id="hm_car_toll_model_type_input" class="hm_car_toll_select_car_inputs form-control" style="">
							  <option value="" disabled selected>انتخاب کنید</option>
						   </select>
						</div>
						<div class="col-sm-2">
						  <div class="hm_car_column_title">نام معادل</div>
						  <input id="hm_car_toll_official_name" type="text" class="form-control" disabled>
						</div>
						<div class="col-sm-2">
						  <div class="hm_car_column_title">بهای فزوش</div>
						  <input id="hm_car_toll_official_price" type="text" class="form-control" disabled>
						</div>
						<div class="col-sm-2 ">
							<div class="hm_car_column_title"    style="visibility: hidden;">.</div>
							<button type="button" id="add_new_car_to_db" class="btn btn-default">افزودن</button>
						</div>
					  </div>
					</div>

					<div id="hmct_ajax_response_target" style="display:none;">
						
					</div>
						
				</form>
				
				<div id="car_toll_loading_ajax_result_table" style="position:absolute;display:none;right:8px;margin-top:22px;" class="lds-dual-ring "></div>
				
				<div id="hmct_result_section"  style="display:none;">
					<table id="hmct_result_car_table" class="display cell-border hover " style="">
						<thead>
							<tr>
								<th>آیدی</th>
								<th>تولید کننده</th>
								<th>مدل</th>
								<th class="hmct_tip_name_class">تیپ</th>
								<th>نام معادل</th>
								<th>بهای فروش</th>
							</tr>
						</thead>
						<tfoot>
							
						</tfoot>
					</table>
				</div>
	
			</div>	
		</div>	
		<?php
		}
		public static function ajax_request() {
			self::handel_ajax();
			die(0);
		}
		public static function echo_shortcode($atts) { 
			extract( shortcode_atts( array(
				'expand' => '',
			), $atts) );
			global $paged;
			ob_start();
			$plugin_dir_url = plugin_dir_url( __FILE__ ); 
			?>
			<script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
			<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
			
			<script>
				<?php 
					$admin_ajax_url =  admin_url( 'admin-ajax.php' );
					echo "admin_ajax_url = '".$admin_ajax_url."';";
					echo "this_site_url = '".get_site_url()."';";//http://www.example.com
				?>
			</script>
			<script type="text/javascript" src="<?php echo hmct_url.'assets/front.js?v='.hm_car_toll_version; ?>"></script>
			<link href="<?php echo hmct_url.'assets/front.css?v='.hm_car_toll_version; ?>" rel="stylesheet">
			<script>
			jQuery(document).ready( function () {
				hmct_get_from_api(); 
			} );
			</script>
			<div id="hm_car_toll_main_wrapper" style="background-image: url(<?php echo hmct_url ?>assets/img/back.jpg);">
				<div id="hm_car_toll_main_inner">
					<form id="regForm" action="">
						<div class="car_toll_title">
						محاسبه عوارض خودرو
						<div id="car_toll_loading_ajax_select" style="position:absolute;"class="lds-dual-ring hmct_loading"></div>
						</div>
						<div class="car_toll_disc"></div>
						
						<div class="container car_toll_select_wrapper">
						  <div class="row">
							<div class="col-sm-4">
							  <div class="hm_car_column_title">سازنده خودرو</div>
							  <select id="hm_car_toll_maker_input" class="hm_car_toll_select_car_inputs form-control">
								  <option value="" disabled selected>انتخاب کنید</option>
								</select>
							</div>
							<div class="col-sm-4">
							  <div class="hm_car_column_title">مدل خودرو</div>
							  <select id="hm_car_toll_model_input"  class="hm_car_toll_select_car_inputs form-control" style="">
								  <option value="" disabled selected>انتخاب کنید</option>
								</select>
							</div>
							<div class="col-sm-4">
							  <div class="hm_car_column_title">تیپ خودرو</div>
							  <select id="hm_car_toll_model_type_input" class="hm_car_toll_select_car_inputs form-control" style="">
								  <option value="" disabled selected>انتخاب کنید</option>
							   </select>
							</div>
							<!--div class="col-sm-3">
							  <div class="hm_car_column_title">سال خودرو</div>
							  <select id="hm_car_toll_year_input" class="hm_car_toll_select_car_inputs  form-control" style="">
								  <option value="" disabled selected>انتخاب کنید</option>
							  </select>
							</div -->
						  </div>
						</div>
						<div id="hmct_car_not_found" style="display: none;">قیمت پایه خودروی مورد نظر هنوز در سیستم ثبت نشده است</div>
						<div id="hmct_ajax_response_target" class="car_toll_result_wrapper" style="">
							<div id="hmct_ajax_response_target_inner" class="container car_toll_result_wrapper_inner" style="">
								<div class="row">
									<div class="col-sm-4 hmct_result_col">
										<div class="hmct_result_col_inner">
										  <div class="hm_car_toll_column_title">مالیات شماره گذاری</div>
										  <div class="hm_car_toll_column_price">
											<div class="hmct_column_price_number" id="hmct_maliat_shomare_gozari">------- تومان </div>
										  </div>
										</div>
									</div>
									<div class="col-sm-4 hmct_result_col">
										<div class="hmct_result_col_inner">
										  <div class="hm_car_toll_column_title">عوارض شماره گذاری</div>
										  <div class="hm_car_toll_column_price">
											<div class="hmct_column_price_number" id="hmct_avarez_shomare_gozari">------- تومان </div>
										  </div>
										</div>
									</div>
									<div class="col-sm-4 hmct_result_col">
										<div class="hmct_result_col_inner">
										  <div class="hm_car_toll_column_title">عوارض سالیانه</div>
										  <div class="hm_car_toll_column_price">
											<div class="hmct_column_price_number" id="hmct_avarez_salianeh">------- تومان </div>
										  </div>
										</div>
									</div>
								</div>
							</div>
						</div>
							
					</form>
				</div>	
			</div>								   
			
			<?php
			$out = ob_get_clean();
			return $out;
		}
		private static function get_settings() {
			self::$settings = get_option( 'hm_car_toll_settings' );
			return self::$settings;
		}
		public static function enqueue_backend() {
			wp_enqueue_script("jquery");
			//wp_enqueue_style('back_css', plugins_url('assets/back.css',__FILE__ ),'',hm_car_toll_version);
			//wp_enqueue_script('back_js', plugins_url('assets/back.js',__FILE__ ),array('jquery'),hm_car_toll_version);
		}
		public static function enqueue_front(){
			wp_enqueue_script("jquery");
			//wp_enqueue_script('sr_leaflet_js', plugins_url('leaflet/leaflet.js',__FILE__ ),array('jquery'),hm_car_toll_version);
			//$data = array('name_1'   => admin_url( 'admin-ajax.php' ),'a_value' => '10');
			//wp_localize_script('sr_front_js', 'pefix_handel', $data);
			//wp_enqueue_style('sr_front_css', plugins_url('assets/front.css',__FILE__ ),'',hm_car_toll_version);
			//wp_enqueue_style('sr_leaflet', plugins_url('leaflet/leaflet.css',__FILE__ ),'',hm_car_toll_version);
		}
		public static function add_settings_link( $links, $file ) {
			$settings = self::get_settings();
			if ( current_user_can( 'manage_options' ) ) {
				$url = admin_url( 'edit.php?post_type=blocked_ip&page=hm_car_toll' );
				$links = (array) $links;
				$links[] = sprintf( '<a href="%s">%s</a>', $url, __( 'Settings', 'hm-car-toll' ) );
			}
			return $links;
		}
		public static function activate() {
			if (! wp_next_scheduled ( 'scheduled_hm_car_toll_email' )) {
				$settings = self::get_settings();
				wp_schedule_event(time(), $settings['ip_send_report_period'], 'scheduled_hm_car_toll_email');
			}
			$settings = array(
				'ip_max_allowed_attempts' => get_option( 'ip_max_allowed_attempts','6' ),
				'ip_reset_attempts_after' => get_option( 'ip_reset_attempts_after','23' ),
			);
			add_option( 'hm_car_toll_settings', $settings );
		}
		public static function deactivat() {
		}
		public static function uninstall() {
			delete_option( 'hm_car_toll_settings' );
		}
	}
	add_action( 'plugins_loaded', array( 'hm_car_toll', 'init_actions' ) );
	register_activation_hook( __FILE__, array( 'hm_car_toll', 'activate' ) );
	register_deactivation_hook(__FILE__, array( 'hm_car_toll', 'deactivat'));
}
function hmct_my_admin_footer_function() {
	//update_option( 'tttttttttttt', $data );
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export(get_option( 'tttttttttttt',true ), true) . "\n ?>");
	?></div><?php 
	delete_option( 'tttttttttttt');
}
//add_action('admin_footer', 'my_admin_footer_function');
function hmct_test_sss(){
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export('' , true) . "\n ?>");
	?></div><?php 
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export('' , true) . "\n ?>");
	?></div><?php 
}